/**
 * This code was GENERATED using the solita package.
 * Please DO NOT EDIT THIS FILE, instead rerun solita to update it or write a wrapper to add functionality.
 *
 * See: https://github.com/metaplex-foundation/solita
 */
import * as web3 from '@solana/web3.js';
import * as beet from '@metaplex-foundation/beet';
import * as beetSolana from '@metaplex-foundation/beet-solana';
/**
 * Arguments used to create {@link DepositReceipt}
 * @category Accounts
 * @category generated
 */
export type DepositReceiptArgs = {
    base: web3.PublicKey;
    owner: web3.PublicKey;
    stakePool: web3.PublicKey;
    stakePoolDepositStakeAuthority: web3.PublicKey;
    depositTime: beet.bignum;
    lstAmount: beet.bignum;
    coolDownSeconds: beet.bignum;
    initialFeeBps: number;
    bumpSeed: number;
    reserved: number[];
};
/**
 * Holds the data for the {@link DepositReceipt} Account and provides de/serialization
 * functionality for that data
 *
 * @category Accounts
 * @category generated
 */
export declare class DepositReceipt implements DepositReceiptArgs {
    readonly base: web3.PublicKey;
    readonly owner: web3.PublicKey;
    readonly stakePool: web3.PublicKey;
    readonly stakePoolDepositStakeAuthority: web3.PublicKey;
    readonly depositTime: beet.bignum;
    readonly lstAmount: beet.bignum;
    readonly coolDownSeconds: beet.bignum;
    readonly initialFeeBps: number;
    readonly bumpSeed: number;
    readonly reserved: number[];
    private constructor();
    /**
     * Creates a {@link DepositReceipt} instance from the provided args.
     */
    static fromArgs(args: DepositReceiptArgs): DepositReceipt;
    /**
     * Deserializes the {@link DepositReceipt} from the data of the provided {@link web3.AccountInfo}.
     * @returns a tuple of the account data and the offset up to which the buffer was read to obtain it.
     */
    static fromAccountInfo(accountInfo: web3.AccountInfo<Buffer>, offset?: number): [DepositReceipt, number];
    /**
     * Retrieves the account info from the provided address and deserializes
     * the {@link DepositReceipt} from its data.
     *
     * @throws Error if no account info is found at the address or if deserialization fails
     */
    static fromAccountAddress(connection: web3.Connection, address: web3.PublicKey, commitmentOrConfig?: web3.Commitment | web3.GetAccountInfoConfig): Promise<DepositReceipt>;
    /**
     * Provides a {@link web3.Connection.getProgramAccounts} config builder,
     * to fetch accounts matching filters that can be specified via that builder.
     *
     * @param programId - the program that owns the accounts we are filtering
     */
    static gpaBuilder(programId?: web3.PublicKey): beetSolana.GpaBuilder<{
        base: any;
        owner: any;
        stakePool: any;
        stakePoolDepositStakeAuthority: any;
        depositTime: any;
        lstAmount: any;
        coolDownSeconds: any;
        initialFeeBps: any;
        bumpSeed: any;
        reserved: any;
    }>;
    /**
     * Deserializes the {@link DepositReceipt} from the provided data Buffer.
     * @returns a tuple of the account data and the offset up to which the buffer was read to obtain it.
     */
    static deserialize(buf: Buffer, offset?: number): [DepositReceipt, number];
    /**
     * Serializes the {@link DepositReceipt} into a Buffer.
     * @returns a tuple of the created Buffer and the offset up to which the buffer was written to store it.
     */
    serialize(): [Buffer, number];
    /**
     * Returns the byteSize of a {@link Buffer} holding the serialized data of
     * {@link DepositReceipt}
     */
    static get byteSize(): number;
    /**
     * Fetches the minimum balance needed to exempt an account holding
     * {@link DepositReceipt} data from rent
     *
     * @param connection used to retrieve the rent exemption information
     */
    static getMinimumBalanceForRentExemption(connection: web3.Connection, commitment?: web3.Commitment): Promise<number>;
    /**
     * Determines if the provided {@link Buffer} has the correct byte size to
     * hold {@link DepositReceipt} data.
     */
    static hasCorrectByteSize(buf: Buffer, offset?: number): boolean;
    /**
     * Returns a readable version of {@link DepositReceipt} properties
     * and can be used to convert to JSON and/or logging
     */
    pretty(): {
        base: string;
        owner: string;
        stakePool: string;
        stakePoolDepositStakeAuthority: string;
        depositTime: any;
        lstAmount: any;
        coolDownSeconds: any;
        initialFeeBps: number;
        bumpSeed: number;
        reserved: number[];
    };
}
/**
 * @category Accounts
 * @category generated
 */
export declare const depositReceiptBeet: beet.BeetStruct<DepositReceipt, DepositReceiptArgs>;
