"use strict";
/**
 * This code was GENERATED using the solita package.
 * Please DO NOT EDIT THIS FILE, instead rerun solita to update it or write a wrapper to add functionality.
 *
 * See: https://github.com/metaplex-foundation/solita
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.depositReceiptBeet = exports.DepositReceipt = void 0;
const web3 = __importStar(require("@solana/web3.js"));
const beet = __importStar(require("@metaplex-foundation/beet"));
const beetSolana = __importStar(require("@metaplex-foundation/beet-solana"));
const customSerializer = __importStar(require("../../custom/deposit-receipt-serializer"));
/**
 * Holds the data for the {@link DepositReceipt} Account and provides de/serialization
 * functionality for that data
 *
 * @category Accounts
 * @category generated
 */
class DepositReceipt {
    constructor(base, owner, stakePool, stakePoolDepositStakeAuthority, depositTime, lstAmount, coolDownSeconds, initialFeeBps, bumpSeed, reserved /* size: 256 */) {
        this.base = base;
        this.owner = owner;
        this.stakePool = stakePool;
        this.stakePoolDepositStakeAuthority = stakePoolDepositStakeAuthority;
        this.depositTime = depositTime;
        this.lstAmount = lstAmount;
        this.coolDownSeconds = coolDownSeconds;
        this.initialFeeBps = initialFeeBps;
        this.bumpSeed = bumpSeed;
        this.reserved = reserved;
    }
    /**
     * Creates a {@link DepositReceipt} instance from the provided args.
     */
    static fromArgs(args) {
        return new DepositReceipt(args.base, args.owner, args.stakePool, args.stakePoolDepositStakeAuthority, args.depositTime, args.lstAmount, args.coolDownSeconds, args.initialFeeBps, args.bumpSeed, args.reserved);
    }
    /**
     * Deserializes the {@link DepositReceipt} from the data of the provided {@link web3.AccountInfo}.
     * @returns a tuple of the account data and the offset up to which the buffer was read to obtain it.
     */
    static fromAccountInfo(accountInfo, offset = 0) {
        return DepositReceipt.deserialize(accountInfo.data, offset);
    }
    /**
     * Retrieves the account info from the provided address and deserializes
     * the {@link DepositReceipt} from its data.
     *
     * @throws Error if no account info is found at the address or if deserialization fails
     */
    static async fromAccountAddress(connection, address, commitmentOrConfig) {
        const accountInfo = await connection.getAccountInfo(address, commitmentOrConfig);
        if (accountInfo == null) {
            throw new Error(`Unable to find DepositReceipt account at ${address}`);
        }
        return DepositReceipt.fromAccountInfo(accountInfo, 0)[0];
    }
    /**
     * Provides a {@link web3.Connection.getProgramAccounts} config builder,
     * to fetch accounts matching filters that can be specified via that builder.
     *
     * @param programId - the program that owns the accounts we are filtering
     */
    static gpaBuilder(programId = new web3.PublicKey('4yQFAAaf4wCKF375qihmKcHJkpkgAj8RoBxvNqt2KWf1')) {
        return beetSolana.GpaBuilder.fromStruct(programId, exports.depositReceiptBeet);
    }
    /**
     * Deserializes the {@link DepositReceipt} from the provided data Buffer.
     * @returns a tuple of the account data and the offset up to which the buffer was read to obtain it.
     */
    static deserialize(buf, offset = 0) {
        return resolvedDeserialize(buf, offset);
    }
    /**
     * Serializes the {@link DepositReceipt} into a Buffer.
     * @returns a tuple of the created Buffer and the offset up to which the buffer was written to store it.
     */
    serialize() {
        return resolvedSerialize(this);
    }
    /**
     * Returns the byteSize of a {@link Buffer} holding the serialized data of
     * {@link DepositReceipt}
     */
    static get byteSize() {
        return exports.depositReceiptBeet.byteSize;
    }
    /**
     * Fetches the minimum balance needed to exempt an account holding
     * {@link DepositReceipt} data from rent
     *
     * @param connection used to retrieve the rent exemption information
     */
    static async getMinimumBalanceForRentExemption(connection, commitment) {
        return connection.getMinimumBalanceForRentExemption(DepositReceipt.byteSize, commitment);
    }
    /**
     * Determines if the provided {@link Buffer} has the correct byte size to
     * hold {@link DepositReceipt} data.
     */
    static hasCorrectByteSize(buf, offset = 0) {
        return buf.byteLength - offset === DepositReceipt.byteSize;
    }
    /**
     * Returns a readable version of {@link DepositReceipt} properties
     * and can be used to convert to JSON and/or logging
     */
    pretty() {
        return {
            base: this.base.toBase58(),
            owner: this.owner.toBase58(),
            stakePool: this.stakePool.toBase58(),
            stakePoolDepositStakeAuthority: this.stakePoolDepositStakeAuthority.toBase58(),
            depositTime: this.depositTime,
            lstAmount: this.lstAmount,
            coolDownSeconds: this.coolDownSeconds,
            initialFeeBps: this.initialFeeBps,
            bumpSeed: this.bumpSeed,
            reserved: this.reserved,
        };
    }
}
exports.DepositReceipt = DepositReceipt;
/**
 * @category Accounts
 * @category generated
 */
exports.depositReceiptBeet = new beet.BeetStruct([
    ['base', beetSolana.publicKey],
    ['owner', beetSolana.publicKey],
    ['stakePool', beetSolana.publicKey],
    ['stakePoolDepositStakeAuthority', beetSolana.publicKey],
    ['depositTime', beet.u64],
    ['lstAmount', beet.u64],
    ['coolDownSeconds', beet.u64],
    ['initialFeeBps', beet.u32],
    ['bumpSeed', beet.u8],
    ['reserved', beet.uniformFixedSizeArray(beet.u8, 256)],
], DepositReceipt.fromArgs, 'DepositReceipt');
const serializer = customSerializer;
const resolvedSerialize = typeof serializer.serialize === 'function'
    ? serializer.serialize.bind(serializer)
    : exports.depositReceiptBeet.serialize.bind(exports.depositReceiptBeet);
const resolvedDeserialize = typeof serializer.deserialize === 'function'
    ? serializer.deserialize.bind(serializer)
    : exports.depositReceiptBeet.deserialize.bind(exports.depositReceiptBeet);
